import { IOverflow } from "./interfaces";
import { OverflowHashCode } from "./OverflowHashCode";
import { OverflowHashCodeBig } from "./OverflowHashCodeBig";
export declare namespace Overflow {
    const Zero8: IOverflow<number>;
    const Min8: IOverflow<number>;
    const Max8: IOverflow<number>;
    const MaxU8: IOverflow<number>;
    const Zero16: IOverflow<number>;
    const Min16: IOverflow<number>;
    const Max16: IOverflow<number>;
    const MaxU16: IOverflow<number>;
    const Zero: IOverflow<number>;
    const Min: IOverflow<number>;
    const Max: IOverflow<number>;
    const MaxU: IOverflow<number>;
    const HashCode: OverflowHashCode;
    const ZeroLong: IOverflow<number>;
    const MinLong: IOverflow<number>;
    const MaxLong: IOverflow<number>;
    const HashCodeLong: OverflowHashCode;
    const Zero64: IOverflow<string>;
    const Min64: IOverflow<string>;
    const Max64: IOverflow<string>;
    const MaxU64: IOverflow<string>;
    const HashCode64: OverflowHashCodeBig;
    const Zero128: IOverflow<string>;
    const Min128: IOverflow<string>;
    const Max128: IOverflow<string>;
    const MaxU128: IOverflow<string>;
    const HashCode128: OverflowHashCodeBig;
    const Zero256: IOverflow<string>;
    const Min256: IOverflow<string>;
    const Max256: IOverflow<string>;
    const MaxU256: IOverflow<string>;
    const HashCode256: OverflowHashCodeBig;
    const Zero512: IOverflow<string>;
    const Min512: IOverflow<string>;
    const Max512: IOverflow<string>;
    const MaxU512: IOverflow<string>;
    const HashCode512: OverflowHashCodeBig;
    const Zero1024: IOverflow<string>;
    const Min1024: IOverflow<string>;
    const Max1024: IOverflow<string>;
    const MaxU1024: IOverflow<string>;
    const HashCode1024: OverflowHashCodeBig;
    const Zero2048: IOverflow<string>;
    const Min2048: IOverflow<string>;
    const Max2048: IOverflow<string>;
    const MaxU2048: IOverflow<string>;
    const HashCode2048: OverflowHashCodeBig;
    const ZeroInfinity: IOverflow<string>;
    function custom(value: number, MIN_SAFE_VALUE: number, MAX_SAFE_VALUE: number): IOverflow<number>;
    function byte(value?: number): IOverflow<number>;
    function ubyte(value?: number): IOverflow<number>;
    function short(value?: number): IOverflow<number>;
    function ushort(value?: number): IOverflow<number>;
    function int(value?: number): IOverflow<number>;
    function uint(value?: number): IOverflow<number>;
    function long(value?: number): IOverflow<number>;
    function ulong(value?: number): IOverflow<number>;
    function big64(value?: string | number): IOverflow<string>;
    function ubig64(value?: string | number): IOverflow<string>;
    function big128(value?: string | number): IOverflow<string>;
    function ubig128(value?: string | number): IOverflow<string>;
    function big256(value?: string | number): IOverflow<string>;
    function ubig256(value?: string | number): IOverflow<string>;
    function big512(value?: string | number): IOverflow<string>;
    function ubig512(value?: string | number): IOverflow<string>;
    function big1024(value?: string | number): IOverflow<string>;
    function ubig1024(value?: string | number): IOverflow<string>;
    function big2048(value?: string | number): IOverflow<string>;
    function ubig2048(value?: string | number): IOverflow<string>;
    function bigInfinity(value?: string | number): IOverflow<string>;
}
